<template>
    <base-card>
        <form @submit.prevent="subirForm">
            <div class="form-control" :class="{invalid: !nombre.esValido}">
                <label for="nombre">Nombre</label>
                <input type="text" id="nombre" v-model.trim="nombre.val" @blur="limpiarValido('nombre')"/>
                <p v-if="!nombre.esValido">Debe ingresar un nombre.</p>
            </div>
            <div class="form-control" :class="{invalid: !apellido.esValido}">
                <label for="apellido">Apellido</label>
                <input type="text" id="apellido" v-model.trim="apellido.val" @blur="limpiarValido('apellido')"/>
                <p v-if="!apellido.esValido">Debe ingresar un apellido.</p>
            </div>
            <div class="form-control" :class="{invalid: !edad.esValido}">
                <label for="edad">Edad</label>
                <input type="number" id="edad" v-model.number="edad.val" @blur="limpiarValido('edad')"/>
                <p v-if="!edad.esValido">Debe ingresar la edad.</p>
            </div>
            <div class="form-control" :class="{invalid: !descripcion.esValido}">
                <label for="especie">Descripcion</label>
                <textarea name="" id="description" rows="5" v-model.trim="descripcion.val" @blur="limpiarValido('descripcion')"></textarea>
                <p v-if="!descripcion.esValido">Debe ingresar la descripcion.</p>
            </div>
            <p v-if="!formEsValido">Porfavor ingrese los campos correctamente y vuelva a enviar.</p>
            <base-button>Registrar</base-button>
        </form>
    </base-card>
</template>
<script>
export default {
    data() {
        return{
            nombre:{
                val:'',
                esValido:true
            },
            apellido:{
                val:'',
                esValido:true
            },
            edad:{
                val:null,
                esValido:true
            },
            descripcion:{
                val:'',
                esValido:true
            },
            formEsValido:true

        };
    },
    methods:{
        limpiarValido(input){
            this[input].esValido=true;
            this.formEsValido=true;
        },
        validaForm(){
            this.formEsValido=true;
            if(this.nombre.val===''){
                this.nombre.esValido=false;
                this.formEsValido=false;
            }
            if(this.apellido.val===''){
                this.apellido.esValido=false;
                this.formEsValido=false;
            }
            if(!this.edad.val||this.edad.val<0){
                this.edad.esValido=false;
                this.formEsValido=false;
            }
            if(this.descripcion.val===''){
                this.descripcion.esValido=false;
                this.formEsValido=false;
            }
        },
        subirForm(){
            this.validaForm();
            if(!this.formEsValido){
                return;
            }
            const formData={
                nom:this.nombre.val,
                sexo:this.apellido.val,
                edad:this.edad.val,
                desc:this.descripcion.val
            };
            console.log(formData);
            // this.$store.dispatch('mascotas/registrarMascota', formData);
            // this.$router.replace('/mascotas');
        },
        guardarData(){

        }
    }
}
</script>
<style scoped>
.form-control {
  margin: 0.5rem 0;
}

label {
  font-weight: bold;
  display: block;
  margin-bottom: 0.5rem;
}

input[type='radio'] + label {
  font-weight: normal;
  display: inline;
  margin: 0 0 0 0.5rem;
}

input,
textarea {
  display: block;
  width: 100%;
  border: 1px solid #ccc;
  font: inherit;
}

input:focus,
textarea:focus {
  background-color: #f0e6fd;
  outline: none;
  border-color: #3d008d;
}

input[type='radio'] {
  display: inline;
  width: auto;
  border: none;
}

input[type='radio']:focus {
  outline: #3d008d solid 1px;
}

h3 {
  margin: 0.5rem 0;
  font-size: 1rem;
}

.invalid label{
  color: red;
}

.invalid h3{
  color: red;
}


.invalid input,
.invalid textarea {
  border: 1px solid red;
}
</style>